# -*- coding: utf-8 -*-

###########################################################################
## 程序设计 danscort yu (c)2021
## www.phoenixp2p.com
##
## Restore program for XFile server
## 额外的说明请参考 sync.py
###########################################################################
import xfile




                             

    

             

##下面是主程序
                
if __name__ == '__main__':
    # When this module is run (not imported) then create the app
    # 
    frm = xfile.MainClass()
    if(xfile._debugmode):
        xfile._ftp.set_debuglevel(2)
        xfile._ftps.set_debuglevel(2)
    print("Restore program for XFile by danscort yu [2021.07.01]")
    print("License: https://www.phoenixp2p.com/cn/xlic.htm")
    #由于该死的utf8-bom 可能存在 因此这里不得不采用连续尝试 先尝试带bom 如果失败 再尝试不带bom方式
    if(frm.FuncLoadConfigFile(True)==False):
        if(xfile._debugmode):
            print("Error load config file with utf8-bom")
        if(frm.FuncLoadConfigFile(False)==False):
            print("Fatal error: failed to load config file in bom and no bom mode.")    
            frm.FuncExit()

    #为了防止出大意外 这里禁止将内容直接备份到根目录下，因为万一是同步模式并且设置错误，那么服务器上备份目录下的内容就会被误删除，后果太严重了       
    if(len(xfile.set_serverbkdir)<=1):
        print("Error: bad set of remote backup dir")
        frm.FuncExit( )       
    #如果设置了dnsfile  那么就尝试装入吧
    if(xfile.set_addrfromdns):
        frm.FuncLoadDnsFile( )
    else:
        #跳过
        print("Dns file is skipped")  
    #这里增加一条 显示服务器地址
    print("Server address : " + xfile.set_serveraddr)      
    if(frm.ConnectToServer()==False):
        if(xfile._debugmode):
            print("Error to connect to server")
        frm.FuncExit()

    str1=frm.FuncSendRawCmd2("SLST","0")
    if(xfile._debugmode):
        #只在调试模式显示
        print(str1)
    if(len(str1)<4):
        frm.FuncExit()
    if(frm.FuncGetNumFromResponse(str1.strip())>=400):
        if(xfile._debugmode):
            print("Bad response from server of SLST")
        frm.FuncExit()
    #如果用户设置了账户反馈码 那么还需要对账户反馈码进行校验 能过这个校验的蜜罐服务器目前是不存在的 除非二次sha256加盐校验被破解了
    if(frm.FuncCheckRespcode()==False):
        print("Fatal error, check account response code failed")
        frm.FuncExit( )
    
    
    #frm.FuncSendRawCmd2("SLST","0")
    ##由于python ftplib ssl 实现存在bug 这个bug 目前没有被修复 因此必须强行关闭数据端ssl
    if(xfile.set_tls):
        #注意 这里必须是False python ftplib 存在bug
        frm.FuncSetProt_P(False)
        
    ##################################################################################
    ##
    ##
    ## 如果你要实现自己的的扩展功能，例如批量改名等，那么请将你的代码放到下面，而把原来的代码注销或者删除就可以
    ## 上面的部分是自动实现XFile服务器登录的代码，不建议改动
    ##
    ##
    ###################################################################################

    if(frm.FuncTestDirRW(xfile.set_localbkdir,False)==False):
        print("Fatal error: local path not exist or need sudo :"+xfile.set_localbkdir)
        frm.FuncExit( )

    frm.FuncRestore(xfile.set_localbkdir,xfile.set_serverbkdir)

    ##这里如果设置有第二个恢复目录 那么继续执行
    if(len(xfile.set_localbkdir2)>0 and len(xfile.set_serverbkdir2)>0 and frm.FuncTestDirRW(xfile.set_localbkdir2,False)):
        print("======Second restore operation======")
        frm.FuncRestore(xfile.set_localbkdir2,xfile.set_serverbkdir2)

    print("========All done========")
    frm.FuncDisconnect
    frm.FuncExit( )
    
                                
